#include "helloworld.hpp"

using namespace std;

helloworld::helloworld(DDSDomainParticipant *participant) : participant_ (participant)
{
    //Getting QoS files
    string sysconf_dir(SYSCONFDIR);
    qos_file_ = sysconf_dir + "qos/helloworld_publisher_qos.xml";
    cout << qos_file_ << endl;

    //TODO set QoS configuration to Publisher, Topic and DataWriter
    
    publisher_ = participant_->create_publisher(
	        DDS_PUBLISHER_QOS_DEFAULT, NULL /* listener */, DDS_STATUS_MASK_NONE);
	if (publisher_ == NULL) {
		printf("create_publisher error\n");
	}
	/* Register type before creating topic */
	type_name_ = helloworld_messageTypeSupport::get_type_name();
	retcode_ = helloworld_messageTypeSupport::register_type(
		participant_, type_name_);
	if (retcode_ != DDS_RETCODE_OK) {
		printf("register_type error %d\n", retcode_);
	}

	topic_ = participant_->create_topic(
		"HelloWorld_message",
		type_name_, DDS_TOPIC_QOS_DEFAULT, NULL /* listener */,
		DDS_STATUS_MASK_NONE);
	
	if (topic_ == NULL) {
	      	printf("create_topic error\n");
	}
	

	writer_ = publisher_->create_datawriter(
		topic_, DDS_DATAWRITER_QOS_DEFAULT, NULL /* listener */,
		DDS_STATUS_MASK_NONE);
	if (writer_ == NULL) {
	        printf("create_datawriter error\n");
	}
	    
	helloworld_message_writer_ = helloworld_messageDataWriter::narrow(writer_);
	
	if (helloworld_message_writer_ == NULL) {
		printf("DataWriter narrow error\n");
	}
	
	instance_ = helloworld_messageTypeSupport::create_data();
	if (instance_ == NULL) {
		printf("helloworld_messageTypeSupport::create_data error\n");
	}
}



string helloworld::get_value(void)
{
	return "Hello world";
}


void helloworld::publish_information(void) 
{
	strcpy(instance_->message, get_value().c_str());

	retcode_ = helloworld_message_writer_->write(*instance_, instance_handle_);
        if (retcode_ != DDS_RETCODE_OK) {
            printf("write error %d\n", retcode_);
        }
	printf("Imprimiendo %s\n",instance_->message);
        NDDSUtility::sleep(send_period_);
}



